#if USE_SHFL_REDUCE

#if 0

#define sum1(a1, ...)				\
  reduce_in_block < TYPE, BLOCK_SIZE >          \
  ( S_Reg[a1], w+BX, z+a1 )

#define sum2(a1,a2, ...)			\
  reduce2_in_block< TYPE, BLOCK_SIZE >          \
  ( S_Reg[a1], S_Reg[a2], w+BX, z+a1 )

#define sum3(a1,a2,a3, ...)				\
  reduce3_in_block< TYPE, BLOCK_SIZE >                  \
  ( S_Reg[a1], S_Reg[a2], S_Reg[a3], w+BX, z+a1 )

#define sum4(a1,a2,a3,a4, ...)                                  \
  reduce4_in_block< TYPE, BLOCK_SIZE >				\
  ( S_Reg[a1], S_Reg[a2], S_Reg[a3], S_Reg[a4], w+BX, z+a1 )

#define sum5(a1,a2,a3,a4,a5, ...)                               \
  reduce5_in_block< TYPE, BLOCK_SIZE >				\
  ( S_Reg[a1], S_Reg[a2], S_Reg[a3], S_Reg[a4], S_Reg[a5],	\
    w+BX, z+a1 )

#define sum6(a1,a2,a3,a4,a5,a6, ...)		\
  ( sum4(a1,a2,a3,a4), sum2(a5,a6) )

#define sum7(a1,a2,a3,a4,a5,a6,a7, ...)		\
  ( sum4(a1,a2,a3,a4), sum3(a5,a6,a7) )

#define sum8(a1,a2,a3,a4,a5,a6,a7,a8, ...)      \
  ( sum4(a1,a2,a3,a4), sum4(a5,a6,a7,a8) )

#define sum9(a1,a2,a3,a4,a5,a6,a7,a8,a9, ...)   \
  ( sum4(a1,a2,a3,a4), sum5(a5,a6,a7,a8,a9) )

#else

#define sum1(a1, ...)				\
  reduce_in_block < TYPE, BLOCK_SIZE >          \
  ( S_Reg[a1], w+BX, z+a1 )

#define sum2(a1,a2, ...)			\
  reduce2_in_block< TYPE, BLOCK_SIZE >          \
  ( S_Reg[a1], S_Reg[a2], w+BX, z+a1 )

#define sum3(a1,a2,a3, ...)				\
  reduce3_in_block< TYPE, BLOCK_SIZE >                  \
  ( S_Reg[a1], S_Reg[a2], S_Reg[a3], w+BX, z+a1 )

#define sum4(a1,a2,a3,a4, ...)                                  \
  reduce4_in_block< TYPE, BLOCK_SIZE >				\
  ( S_Reg[a1], S_Reg[a2], S_Reg[a3], S_Reg[a4], w+BX, z+a1 )

#define sum5(a1,a2,a3,a4,a5, ...)                               \
  reduce5_in_block< TYPE, BLOCK_SIZE >				\
  ( S_Reg[a1], S_Reg[a2], S_Reg[a3], S_Reg[a4], S_Reg[a5],	\
    w+BX, z+a1 )

#define sum6(a1,a2,a3,a4,a5,a6, ...)                            \
  reduce6_in_block< TYPE, BLOCK_SIZE >				\
  ( S_Reg[a1], S_Reg[a2], S_Reg[a3], S_Reg[a4], S_Reg[a5],	\
    S_Reg[a6], w+BX, z+a1 )

#define sum7(a1,a2,a3,a4,a5,a6,a7, ...)                         \
  reduce7_in_block< TYPE, BLOCK_SIZE >				\
    ( S_Reg[a1], S_Reg[a2], S_Reg[a3], S_Reg[a4], S_Reg[a5],	\
      S_Reg[a6], S_Reg[a7], w+BX, z+a1 )

#define sum8(a1,a2,a3,a4,a5,a6,a7,a8, ...)                      \
  reduce8_in_block< TYPE, BLOCK_SIZE >				\
    ( S_Reg[a1], S_Reg[a2], S_Reg[a3], S_Reg[a4], S_Reg[a5],	\
      S_Reg[a6], S_Reg[a7], S_Reg[a8], w+BX, z+a1 )

#define sum9(a1,a2,a3,a4,a5,a6,a7,a8,a9, ...)                   \
  reduce9_in_block< TYPE, BLOCK_SIZE >				\
    ( S_Reg[a1], S_Reg[a2], S_Reg[a3], S_Reg[a4], S_Reg[a5],	\
      S_Reg[a6], S_Reg[a7], S_Reg[a8], S_Reg[a9], w+BX, z+a1 )

#endif
#else

#define sum1(a1, ...)				\
  sumup_s1s < TYPE, BLOCK_SIZE >		\
  ( S_Reg[a1], w+BX, z+a1 )

#define sum2(a1,a2, ...)			\
  sumup_s2s< TYPE, BLOCK_SIZE >                 \
  ( S_Reg[a1], S_Reg[a2], w+BX, z+a1 )

#define sum3(a1,a2,a3, ...)			\
  ( sum2(a1,a2), sum1(a3) )

#define sum4(a1,a2,a3,a4, ...)                                  \
  sumup_s4s< TYPE, BLOCK_SIZE >					\
  ( S_Reg[a1], S_Reg[a2], S_Reg[a3], S_Reg[a4], w+BX, z+a1 )

#define sum5(a1,a2,a3,a4,a5, ...)		\
  ( sum3(a1,a2,a3), sum2(a4,a5) )

#define sum6(a1,a2,a3,a4,a5,a6, ...)		\
  ( sum4(a1,a2,a3,a4), sum2(a5,a6) )

#define sum7(a1,a2,a3,a4,a5,a6,a7, ...)		\
  ( sum4(a1,a2,a3,a4), sum3(a5,a6,a7) )

#define sum8(a1,a2,a3,a4,a5,a6,a7,a8, ...)      \
  ( sum4(a1,a2,a3,a4), sum4(a5,a6,a7,a8) )

#define sum9(a1,a2,a3,a4,a5,a6,a7,a8,a9, ...)   \
  ( sum4(a1,a2,a3,a4), sum5(a5,a6,a7,a8,a9) )

#endif

