#if 0
<--/****************************************
Automatic Performance Tuning for DSYMV-L
Thu Aug 20 07:29:56 JST 2015
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-750-Ti
****************************************/-->
DEVICE= GeForce-GTX-750-Ti
MP= 5
CG= 500
MAXmem= 2146630912
MAXDIM= 15561
MAXDIM2= 22007
MAXDIM3= 11003
MAXDIM4= 7780
CUDA= 7050
#define CURRENT_GPU 500
#endif
{
//==========
if(blk==-1){
	#include "dsymv-lower-auto2.h"
}
//==========
#if 0
struct dsymv_auto_tuning_param_t { 
	int	BLOCK_SIZE, VX, UX, MULTI, MX; 
} PARAM[22] = {
	{ 32, 4, 32, 6, 9 },
	{ 32, 4, 32, 6, 7 },
	{ 64, 2, 62, 3, 1 },
	{ 64, 2, 62, 3, 4 },
	{ 32, 4, 32, 6, 3 },
	{ 64, 2, 62, 3, 8 },
	{ 64, 3, 24, 5, 8 },
	{ 64, 2, 24, 6, 1 },
	{ 64, 2, 48, 4, 0 },
	{ 64, 2, 62, 3, 5 },
	{ 64, 2, 62, 3, 2 },
	{ 64, 2, 62, 3, 9 },
	{ 64, 2, 62, 3, 7 },
	{ 64, 3, 24, 5, 9 },
	{ 64, 4, 28, 4, 8 },
	{ 64, 2, 50, 4, 9 },
	{ 64, 2, 62, 3, 3 },
	{ 64, 2, 58, 3, 1 },
	{ 64, 2, 16, 8, 4 },
	{ 32, 4, 32, 6, 8 },
	{ 0, 0, 0, 0, 0 }
};
#endif
//==========
switch ( BLK ) {
#if KERNEL_1
case 1:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 4, 32, 6, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_2
case 2:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 4, 32, 6, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_3
case 3:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 62, 3, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_4
case 4:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 62, 3, 4 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_5
case 5:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 4, 32, 6, 3 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_6
case 6:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 62, 3, 8 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_7
case 7:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 3, 24, 5, 8 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_8
case 8:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 24, 6, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_9
case 9:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 48, 4, 0 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_10
case 10:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 62, 3, 5 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_11
case 11:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 62, 3, 2 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_12
case 12:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 62, 3, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_13
case 13:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 62, 3, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_14
case 14:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 3, 24, 5, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_15
case 15:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 28, 4, 8 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_16
case 16:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 50, 4, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_17
case 17:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 62, 3, 3 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_18
case 18:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 58, 3, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_19
case 19:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 16, 8, 4 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_20
case 20:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 4, 32, 6, 8 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
default:
	break;
}
//==========
}
