#if 0
<--/****************************************
Automatic Performance Tuning for SSYMV -U
Wed Aug 26 02:05:45 JST 2015
Host on laplace.aics27.riken.jp
Device is GeForce-GTX-980
****************************************/-->
DEVICE= GeForce-GTX-980
MP= 16
CG= 520
MAXmem= 4294584320
MAXDIM= 22010
MAXDIM2= 31128
MAXDIM3= 15564
MAXDIM4= 11005
CUDA= 6050
#define CURRENT_GPU 520
#endif
{
//==========
if(blk==-1){
	#include "ssymv-upper-auto2.h"
}
//==========
#if 0
struct ssymv_auto_tuning_param_t { 
	int	BLOCK_SIZE, VX, UX, MULTI, MX; 
} PARAM[22] = {
	{ 64, 4, 64, 3, 9 },
	{ 96, 3, 51, 3, 0 },
	{ 64, 4, 64, 3, 1 },
	{ 96, 3, 51, 3, 9 },
	{ 64, 4, 64, 3, 7 },
	{ 64, 3, 63, 3, 9 },
	{ 64, 2, 30, 8, 0 },
	{ 96, 2, 48, 3, 9 },
	{ 64, 2, 34, 7, 1 },
	{ 64, 3, 63, 3, 0 },
	{ 96, 3, 51, 3, 1 },
	{ 32, 4, 32, 8, 9 },
	{ 96, 3, 57, 3, 3 },
	{ 64, 2, 36, 7, 1 },
	{ 96, 3, 72, 2, 2 },
	{ 64, 4, 64, 3, 3 },
	{ 96, 3, 72, 2, 0 },
	{ 96, 3, 57, 3, 0 },
	{ 96, 3, 75, 2, 0 },
	{ 64, 2, 34, 7, 0 },
	{ 0, 0, 0, 0, 0 }
};
#endif
//==========
switch ( BLK ) {
#if KERNEL_1
case 1:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 64, 3, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_2
case 2:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 96, 3, 51, 3, 0 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_3
case 3:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 64, 3, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_4
case 4:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 96, 3, 51, 3, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_5
case 5:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 64, 3, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_6
case 6:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 3, 63, 3, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_7
case 7:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 30, 8, 0 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_8
case 8:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 96, 2, 48, 3, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_9
case 9:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 34, 7, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_10
case 10:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 3, 63, 3, 0 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_11
case 11:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 96, 3, 51, 3, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_12
case 12:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 4, 32, 8, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_13
case 13:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 96, 3, 57, 3, 3 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_14
case 14:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 36, 7, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_15
case 15:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 96, 3, 72, 2, 2 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_16
case 16:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 64, 3, 3 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_17
case 17:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 96, 3, 72, 2, 0 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_18
case 18:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 96, 3, 57, 3, 0 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_19
case 19:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 96, 3, 75, 2, 0 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_20
case 20:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 34, 7, 0 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
default:
	break;
}
//==========
}
