#if 0
<--/****************************************
Automatic Performance Tuning for DSYMV-L
Tue Aug 25 15:32:36 JST 2015
Host on laplace.aics27.riken.jp
Device is GeForce-GTX-980
****************************************/-->
DEVICE= GeForce-GTX-980
MP= 16
CG= 520
MAXmem= 4294584320
MAXDIM= 22010
MAXDIM2= 31128
MAXDIM3= 15564
MAXDIM4= 11005
CUDA= 7000
#define CURRENT_GPU 520
#endif
{
//==========
if(blk==-1){
	#include "dsymv-lower-auto2.h"
}
//==========
#if 0
struct dsymv_auto_tuning_param_t { 
	int	BLOCK_SIZE, VX, UX, MULTI, MX; 
} PARAM[22] = {
	{ 64, 2, 64, 3, 8 },
	{ 64, 3, 27, 6, 9 },
	{ 64, 2, 64, 3, 5 },
	{ 64, 4, 64, 2, 9 },
	{ 64, 2, 64, 3, 4 },
	{ 64, 3, 24, 6, 5 },
	{ 64, 4, 64, 2, 5 },
	{ 64, 2, 64, 3, 1 },
	{ 32, 4, 20, 9, 9 },
	{ 64, 4, 36, 4, 0 },
	{ 64, 4, 36, 4, 7 },
	{ 32, 4, 24, 7, 5 },
	{ 64, 2, 64, 3, 2 },
	{ 64, 2, 64, 3, 7 },
	{ 64, 2, 64, 3, 0 },
	{ 64, 3, 24, 6, 4 },
	{ 64, 2, 62, 3, 5 },
	{ 64, 4, 36, 4, 9 },
	{ 32, 4, 20, 9, 7 },
	{ 64, 3, 60, 2, 2 },
	{ 0, 0, 0, 0, 0 }
};
#endif
//==========
switch ( BLK ) {
#if KERNEL_1
case 1:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 64, 3, 8 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_2
case 2:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 3, 27, 6, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_3
case 3:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 64, 3, 5 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_4
case 4:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 64, 2, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_5
case 5:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 64, 3, 4 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_6
case 6:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 3, 24, 6, 5 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_7
case 7:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 64, 2, 5 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_8
case 8:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 64, 3, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_9
case 9:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 4, 20, 9, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_10
case 10:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 36, 4, 0 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_11
case 11:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 36, 4, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_12
case 12:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 4, 24, 7, 5 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_13
case 13:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 64, 3, 2 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_14
case 14:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 64, 3, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_15
case 15:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 64, 3, 0 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_16
case 16:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 3, 24, 6, 4 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_17
case 17:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 62, 3, 5 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_18
case 18:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 36, 4, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_19
case 19:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 4, 20, 9, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_20
case 20:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 3, 60, 2, 2 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
default:
	break;
}
//==========
}
