#if 0
<--/****************************************
Automatic Performance Tuning for DSYMV-L
Mon Aug 24 01:13:46 JST 2015
Host on newton.aics27.riken.jp
Device is GeForce-GTX-TITAN-Black
****************************************/-->
DEVICE= GeForce-GTX-TITAN-Black
MP= 15
CG= 350
MAXmem= 6433732096
MAXDIM= 26940
MAXDIM2= 38100
MAXDIM3= 19050
MAXDIM4= 13470
CUDA= 7050
#define CURRENT_GPU 350
#endif
{
//==========
if(blk==-1){
	#include "dsymv-lower-auto2.h"
}
//==========
#if 0
struct dsymv_auto_tuning_param_t { 
	int	BLOCK_SIZE, VX, UX, MULTI, MX; 
} PARAM[22] = {
	{ 32, 4, 32, 7, 7 },
	{ 64, 4, 64, 2, 6 },
	{ 64, 4, 24, 4, 1 },
	{ 64, 4, 40, 3, 0 },
	{ 64, 5, 30, 3, 1 },
	{ 32, 4, 32, 6, 6 },
	{ 96, 3, 24, 3, 6 },
	{ 96, 3, 24, 3, 4 },
	{ 32, 4, 32, 7, 1 },
	{ 64, 5, 50, 2, 6 },
	{ 64, 4, 64, 2, 9 },
	{ 64, 4, 36, 3, 5 },
	{ 64, 4, 32, 3, 6 },
	{ 64, 5, 30, 3, 7 },
	{ 96, 3, 24, 3, 3 },
	{ 64, 4, 64, 2, 4 },
	{ 64, 4, 36, 3, 8 },
	{ 64, 4, 24, 4, 7 },
	{ 32, 5, 30, 6, 7 },
	{ 64, 4, 36, 3, 3 },
	{ 0, 0, 0, 0, 0 }
};
#endif
//==========
switch ( BLK ) {
#if KERNEL_1
case 1:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 4, 32, 7, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_2
case 2:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 64, 2, 6 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_3
case 3:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 24, 4, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_4
case 4:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 40, 3, 0 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_5
case 5:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 5, 30, 3, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_6
case 6:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 4, 32, 6, 6 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_7
case 7:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 96, 3, 24, 3, 6 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_8
case 8:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 96, 3, 24, 3, 4 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_9
case 9:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 4, 32, 7, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_10
case 10:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 5, 50, 2, 6 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_11
case 11:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 64, 2, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_12
case 12:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 36, 3, 5 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_13
case 13:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 32, 3, 6 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_14
case 14:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 5, 30, 3, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_15
case 15:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 96, 3, 24, 3, 3 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_16
case 16:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 64, 2, 4 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_17
case 17:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 36, 3, 8 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_18
case 18:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 24, 4, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_19
case 19:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 5, 30, 6, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_20
case 20:
	API(SYMVl_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 36, 3, 3 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
default:
	break;
}
//==========
}
