#if __isDOUBLE__
#define GEMV_N     DGEMV_N
#define GEMV_T     DGEMV_T
#define SYMV_U     DSYMV_U
#define SYMV_L     DSYMV_L
#define TEST_GEMV_N     "magma-dgemv-n"
#define TEST_GEMV_T     "magma-dgemv-t"
#define TEST_SYMV_U     "magma-dsymv-u"
#define TEST_SYMV_L     "magma-dsymv-l"
#define TEST2_GEMV_N    "magma2-dgemv-n"
#define TEST2_GEMV_T    "magma2-dgemv-t"
#define TEST2_SYMV_U    "magma2-dsymv-u"
#define TEST2_SYMV_L    "magma2-dsymv-l"
#define NAME_GEMV_N     "DGEMV -N"
#define NAME_GEMV_T     "DGEMV -T"
#define NAME_SYMV_U     "DSYMV -U"
#define NAME_SYMV_L     "DSYMV -L"
#define magmablasgemv      magmablas_dgemv
#define magmablassymv      magmablas_dsymv
#define magmablasgemv_work      magmablas_dgemv_work
#define magmablassymv_work      magmablas_dsymv_work
#else
#define GEMV_N     SGEMV_N
#define GEMV_T     SGEMV_T
#define SYMV_U     SSYMV_U
#define SYMV_L     SSYMV_L
#define TEST_GEMV_N     "magma-sgemv-n"
#define TEST_GEMV_T     "magma-sgemv-t"
#define TEST_SYMV_U     "magma-ssymv-u"
#define TEST_SYMV_L     "magma-ssymv-l"
#define TEST2_GEMV_N    "magma2-sgemv-n"
#define TEST2_GEMV_T    "magma2-sgemv-t"
#define TEST2_SYMV_U    "magma2-ssymv-u"
#define TEST2_SYMV_L    "magma2-ssymv-l"
#define NAME_GEMV_N     "SGEMV -N"
#define NAME_GEMV_T     "SGEMV -T"
#define NAME_SYMV_U     "SSYMV -U"
#define NAME_SYMV_L     "SSYMV -L"
#define magmablasgemv      magmablas_sgemv
#define magmablassymv      magmablas_ssymv
#define magmablasgemv_work     magmablas_sgemv_work
#define magmablassymv_work     magmablas_ssymv_work
#endif

